<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>github-api-curl</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
</head>
<body>
<h1 id="getting-started-with-the-rest-api">Getting started with the REST API</h1>
<p>Learn the foundations for using the REST API, starting with authentication and some endpoint examples.</p>
<h2 id="in-this-article"><a href="https://docs.github.com/en/rest/guides/getting-started-with-the-rest-api#in-this-article">In this article</a></h2>
<ul>
<li><a href="https://docs.github.com/en/rest/guides/getting-started-with-the-rest-api#overview">Overview</a></li>
<li><a href="https://docs.github.com/en/rest/guides/getting-started-with-the-rest-api#authentication">Authentication</a></li>
<li><a href="https://docs.github.com/en/rest/guides/getting-started-with-the-rest-api#repositories">Repositories</a></li>
<li><a href="https://docs.github.com/en/rest/guides/getting-started-with-the-rest-api#issues">Issues</a></li>
<li><a href="https://docs.github.com/en/rest/guides/getting-started-with-the-rest-api#conditional-requests">Conditional requests</a></li>
</ul>
<p>Let’s walk through core API concepts as we tackle some everyday use cases.</p>
<h2 id="overview"><a href="https://docs.github.com/en/rest/guides/getting-started-with-the-rest-api#overview">Overview</a></h2>
<p>Most applications will use an existing <a href="https://docs.github.com/en/libraries">wrapper library</a> in the language of your choice, but it’s important to familiarize yourself with the underlying API HTTP methods first.</p>
<p>There’s no easier way to kick the tires than through <a href="http://curl.haxx.se/">cURL</a>. If you are using an alternative client, note that you are required to send a valid <a href="https://docs.github.com/en/rest/overview/resources-in-the-rest-api#user-agent-required">User Agent header</a> in your request.</p>
<h3 id="hello-world"><a href="https://docs.github.com/en/rest/guides/getting-started-with-the-rest-api#hello-world">Hello World</a></h3>
<p>Let’s start by testing our setup. Open up a command prompt and enter the following command:</p>
<pre><code>$ curl https://api.github.com/zen

&gt; Keep it logically awesome.</code></pre>
<p>The response will be a random selection from our design philosophies.</p>
<p>Next, let’s <code>GET</code> <a href="https://github.com/defunkt">Chris Wanstrath’s</a> <a href="https://docs.github.com/en/rest/reference/users#get-a-user">GitHub profile</a>:</p>
<pre><code># GET /users/defunkt
$ curl https://api.github.com/users/defunkt

&gt; {
&gt;   &quot;login&quot;: &quot;defunkt&quot;,
&gt;   &quot;id&quot;: 2,
&gt;   &quot;node_id&quot;: &quot;MDQ6VXNlcjI=&quot;,
&gt;   &quot;avatar_url&quot;: &quot;https://avatars.githubusercontent.com/u/2?v=4&quot;,
&gt;   &quot;gravatar_id&quot;: &quot;&quot;,
&gt;   &quot;url&quot;: &quot;https://api.github.com/users/defunkt&quot;,
&gt;   &quot;html_url&quot;: &quot;https://github.com/defunkt&quot;,
&gt;   ...
&gt; }</code></pre>
<p>Mmmmm, tastes like <a href="http://en.wikipedia.org/wiki/JSON">JSON</a>. Let’s add the <code>-i</code> flag to include headers:</p>
<pre><code>$ curl -i https://api.github.com/users/defunkt

&gt; HTTP/2 200
&gt; server: GitHub.com
&gt; date: Thu, 08 Jul 2021 07:04:08 GMT
&gt; content-type: application/json; charset=utf-8
&gt; cache-control: public, max-age=60, s-maxage=60
&gt; vary: Accept, Accept-Encoding, Accept, X-Requested-With
&gt; etag: W/&quot;61e964bf6efa3bc3f9e8549e56d4db6e0911d8fa20fcd8ab9d88f13d513f26f0&quot;
&gt; last-modified: Fri, 01 Nov 2019 21:56:00 GMT
&gt; x-github-media-type: github.v3; format=json
&gt; access-control-expose-headers: ETag, Link, Location, Retry-After, X-GitHub-OTP, X-RateLimit-Limit, X-RateLimit-Remaining, X-RateLimit-Used, X-RateLimit-Resource, X-RateLimit-Reset, X-OAuth-Scopes, X-Accepted-OAuth-Scopes, X-Poll-Interval, X-GitHub-Media-Type, Deprecation, Sunset
&gt; access-control-allow-origin: *
&gt; strict-transport-security: max-age=31536000; includeSubdomains; preload
&gt; x-frame-options: deny
&gt; x-content-type-options: nosniff
&gt; x-xss-protection: 0
&gt; referrer-policy: origin-when-cross-origin, strict-origin-when-cross-origin
&gt; content-security-policy: default-src &#39;none&#39;
&gt; x-ratelimit-limit: 60
&gt; x-ratelimit-remaining: 53
&gt; x-ratelimit-reset: 1625731053
&gt; x-ratelimit-resource: core
&gt; x-ratelimit-used: 7
&gt; accept-ranges: bytes
&gt; content-length: 1305
&gt; x-github-request-id: 9F60:7019:ACC5CD5:B03C931:60E6A368
&gt;
&gt; {
&gt;  &quot;login&quot;: &quot;defunkt&quot;,
&gt;  &quot;id&quot;: 2,
&gt;  &quot;node_id&quot;: &quot;MDQ6VXNlcjI=&quot;,
&gt;  &quot;avatar_url&quot;: &quot;https://avatars.githubusercontent.com/u/2?v=4&quot;,
&gt;  &quot;gravatar_id&quot;: &quot;&quot;,
&gt;  &quot;url&quot;: &quot;https://api.github.com/users/defunkt&quot;,
&gt;  &quot;html_url&quot;: &quot;https://github.com/defunkt&quot;,
&gt;
&gt;   ...
&gt; }</code></pre>
<p>There are a few interesting bits in the response headers. As expected, the <code>Content-Type</code> is <code>application/json</code>.</p>
<p>Any headers beginning with <code>X-</code> are custom headers, and are not included in the HTTP spec. For example:</p>
<ul>
<li><code>X-GitHub-Media-Type</code> has a value of <code>github.v3</code>. This lets us know the <a href="https://docs.github.com/en/rest/overview/media-types">media type</a> for the response. Media types have helped us version our output in API v3. We’ll talk more about that later.</li>
<li>Take note of the <code>X-RateLimit-Limit</code> and <code>X-RateLimit-Remaining</code> headers. This pair of headers indicate <a href="https://docs.github.com/en/rest#rate-limiting">how many requests a client can make</a> in a rolling time period (typically an hour) and how many of those requests the client has already spent.</li>
</ul>
<h2 id="authentication"><a href="https://docs.github.com/en/rest/guides/getting-started-with-the-rest-api#authentication">Authentication</a></h2>
<p>Unauthenticated clients can make 60 requests per hour. To get more requests per hour, we’ll need to <em>authenticate</em>. In fact, doing anything interesting with the GitHub API requires <a href="https://docs.github.com/en/rest#authentication">authentication</a>.</p>
<h3 id="using-personal-access-tokens"><a href="https://docs.github.com/en/rest/guides/getting-started-with-the-rest-api#using-personal-access-tokens">Using personal access tokens</a></h3>
<p>The easiest and best way to authenticate with the GitHub API is by using Basic Authentication <a href="https://docs.github.com/en/rest/overview/other-authentication-methods#via-oauth-and-personal-access-tokens">via OAuth tokens</a>. OAuth tokens include <a href="https://docs.github.com/en/articles/creating-an-access-token-for-command-line-use">personal access tokens</a>.</p>
<p>Use a <code>-u</code> flag to set your username:</p>
<pre><code>$ curl -i -u your_username https://api.github.com/users/octocat
</code></pre>
<p>When prompted, you can enter your OAuth token, but we recommend you set up a variable for it:</p>
<p>You can use <code>-u "username:$token"</code> and set up a variable for <code>token</code> to avoid leaving your token in shell history, which should be avoided.</p>
<pre><code>$ curl -i -u username:$token https://api.github.com/users/octocat
</code></pre>
<p>When authenticating, you should see your rate limit bumped to 5,000 requests an hour, as indicated in the <code>X-RateLimit-Limit</code> header. In addition to providing more calls per hour, authentication enables you to read and write private information using the API.</p>
<p>You can easily <a href="https://docs.github.com/en/articles/creating-an-access-token-for-command-line-use">create a personal access token</a> using your <a href="https://github.com/settings/tokens">Personal access tokens settings page</a>:</p>
<p>To help keep your information secure, we highly recommend setting an expiration for your personal access tokens.</p>
<figure>
<img src="https://docs.github.com/assets/images/personal_token.png" alt="Personal Token selection" /><figcaption>Personal Token selection</figcaption>
</figure>
<p>API requests using an expiring personal access token will return that token’s expiration date via the <code>GitHub-Authentication-Token-Expiration</code> header. You can use the header in your scripts to provide a warning message when the token is close to its expiration date.</p>
<h3 id="get-your-own-user-profile"><a href="https://docs.github.com/en/rest/guides/getting-started-with-the-rest-api#get-your-own-user-profile">Get your own user profile</a></h3>
<p>When properly authenticated, you can take advantage of the permissions associated with your GitHub account. For example, try getting <a href="https://docs.github.com/en/rest/reference/users#get-the-authenticated-user">your own user profile</a>:</p>
<pre><code>$ curl -i -u your_username:your_token https://api.github.com/user

&gt; {
&gt;   ...
&gt;   &quot;plan&quot;: {
&gt;     &quot;space&quot;: 2516582,
&gt;    &quot;collaborators&quot;: 10,
&gt;    &quot;private_repos&quot;: 20,
&gt;    &quot;name&quot;: &quot;medium&quot;
&gt;  }
&gt;   ...
&gt; }</code></pre>
<p>This time, in addition to the same set of public information we retrieved for <span class="citation" data-cites="defunkt">[@defunkt]</span>(https://github.com/defunkt) earlier, you should also see the non-public information for your user profile. For example, you’ll see a <code>plan</code> object in the response which gives details about the GitHub plan for the account.</p>
<h3 id="using-oauth-tokens-for-apps"><a href="https://docs.github.com/en/rest/guides/getting-started-with-the-rest-api#using-oauth-tokens-for-apps">Using OAuth tokens for apps</a></h3>
<p>Apps that need to read or write private information using the API on behalf of another user should use <a href="https://docs.github.com/en/apps/building-integrations/setting-up-and-registering-oauth-apps">OAuth</a>.</p>
<p>OAuth uses <em>tokens</em>. Tokens provide two big features:</p>
<ul>
<li>Revokable access: users can revoke authorization to third party apps at any time</li>
<li>Limited access: users can review the specific access that a token will provide before authorizing a third party app</li>
</ul>
<p>Tokens should be created via a <a href="https://docs.github.com/en/apps/building-oauth-apps/authorizing-oauth-apps">web flow</a>. An application sends users to GitHub to log in. GitHub then presents a dialog indicating the name of the app, as well as the level of access the app has once it’s authorized by the user. After a user authorizes access, GitHub redirects the user back to the application:</p>
<figure>
<img src="https://docs.github.com/assets/images/oauth_prompt.png" alt="GitHub’s OAuth Prompt" /><figcaption>GitHub’s OAuth Prompt</figcaption>
</figure>
<p>Treat OAuth tokens like passwords! Don’t share them with other users or store them in insecure places. The tokens in these examples are fake and the names have been changed to protect the innocent.</p>
<p>Now that we’ve got the hang of making authenticated calls, let’s move along to the <a href="https://docs.github.com/en/rest/reference/repos">Repositories API</a>.</p>
<h2 id="repositories"><a href="https://docs.github.com/en/rest/guides/getting-started-with-the-rest-api#repositories">Repositories</a></h2>
<p>Almost any meaningful use of the GitHub API will involve some level of Repository information. We can <a href="https://docs.github.com/en/rest/reference/repos#get-a-repository"><code>GET</code> repository details</a> in the same way we fetched user details earlier:</p>
<pre><code>$ curl -i https://api.github.com/repos/twbs/bootstrap</code></pre>
<p>In the same way, we can <a href="https://docs.github.com/en/rest/reference/repos#list-repositories-for-the-authenticated-user">view repositories for the authenticated user</a>:</p>
<pre><code>$ curl -i -H &quot;Authorization: token ghp_16C7e42F292c6912E7710c838347Ae178B4a&quot;\
    https://api.github.com/user/repos</code></pre>
<p>Or, we can <a href="https://docs.github.com/en/rest/reference/repos#list-repositories-for-a-user">list repositories for another user</a>:</p>
<pre><code>$ curl -i https://api.github.com/users/octocat/repos</code></pre>
<p>Or, we can <a href="https://docs.github.com/en/rest/reference/repos#list-organization-repositories">list repositories for an organization</a>:</p>
<pre><code>$ curl -i https://api.github.com/orgs/octo-org/repos</code></pre>
<p>The information returned from these calls will depend on which scopes our token has when we authenticate:</p>
<ul>
<li>A token with <code>public_repo</code> <a href="https://docs.github.com/en/apps/building-oauth-apps/understanding-scopes-for-oauth-apps">scope</a> returns a response that includes all public repositories we have access to see on github.com.</li>
<li>A token with <code>repo</code> <a href="https://docs.github.com/en/apps/building-oauth-apps/understanding-scopes-for-oauth-apps">scope</a> returns a response that includes all public and private repositories we have access to see on GitHub.</li>
</ul>
<p>As the <a href="https://docs.github.com/en/rest/reference/repos">docs</a> indicate, these methods take a <code>type</code> parameter that can filter the repositories returned based on what type of access the user has for the repository. In this way, we can fetch only directly-owned repositories, organization repositories, or repositories the user collaborates on via a team.</p>
<pre><code>$ curl -i &quot;https://api.github.com/users/octocat/repos?type=owner&quot;</code></pre>
<p>In this example, we grab only those repositories that octocat owns, not the ones on which she collaborates. Note the quoted URL above. Depending on your shell setup, cURL sometimes requires a quoted URL or else it ignores the query string.</p>
<h3 id="create-a-repository"><a href="https://docs.github.com/en/rest/guides/getting-started-with-the-rest-api#create-a-repository">Create a repository</a></h3>
<p>Fetching information for existing repositories is a common use case, but the GitHub API supports creating new repositories as well. To <a href="https://docs.github.com/en/rest/reference/repos#create-a-repository-for-the-authenticated-user">create a repository</a>, we need to <code>POST</code> some JSON containing the details and configuration options.</p>
<pre><code>$ curl -i -H &quot;Authorization: token ghp_16C7e42F292c6912E7710c838347Ae178B4a&quot;\
    -d &#39;{\
        &quot;name&quot;: &quot;blog&quot;,\
        &quot;auto_init&quot;: true,\
        &quot;private&quot;: true,\
        &quot;gitignore_template&quot;: &quot;nanoc&quot;\
      }&#39;\
    https://api.github.com/user/repos</code></pre>
<p>In this minimal example, we create a new private repository for our blog (to be served on <a href="http://pages.github.com/">GitHub Pages</a>, perhaps). Though the blog will be public, we’ve made the repository private. In this single step, we’ll also initialize it with a README and a <a href="http://nanoc.ws/">nanoc</a>-flavored <a href="https://github.com/github/gitignore">.gitignore template</a>.</p>
<p>The resulting repository will be found at <code>https://github.com/&lt;your_username&gt;/blog</code>. To create a repository under an organization for which you’re an owner, just change the API method from <code>/user/repos</code> to <code>/orgs/&lt;org_name&gt;/repos</code>.</p>
<p>Next, let’s fetch our newly created repository:</p>
<pre><code>$ curl -i https://api.github.com/repos/pengwynn/blog

&gt; HTTP/2 404

&gt; {
&gt;    &quot;message&quot;: &quot;Not Found&quot;
&gt; }</code></pre>
<p>Oh noes! Where did it go? Since we created the repository as <em>private</em>, we need to authenticate in order to see it. If you’re a grizzled HTTP user, you might expect a <code>403</code> instead. Since we don’t want to leak information about private repositories, the GitHub API returns a <code>404</code> in this case, as if to say “we can neither confirm nor deny the existence of this repository.”</p>
<h2 id="issues"><a href="https://docs.github.com/en/rest/guides/getting-started-with-the-rest-api#issues">Issues</a></h2>
<p>The UI for Issues on GitHub aims to provide ‘just enough’ workflow while staying out of your way. With the GitHub <a href="https://docs.github.com/en/rest/reference/issues">Issues API</a>, you can pull data out or create issues from other tools to create a workflow that works for your team.</p>
<p>Just like github.com, the API provides a few methods to view issues for the authenticated user. To <a href="https://docs.github.com/en/rest/reference/issues#list-issues-assigned-to-the-authenticated-user">see all your issues</a>, call <code>GET /issues</code>:</p>
<pre><code>$ curl -i -H &quot;Authorization: token ghp_16C7e42F292c6912E7710c838347Ae178B4a&quot;\
    https://api.github.com/issues</code></pre>
<p>To get only the <a href="https://docs.github.com/en/rest/reference/issues#list-issues-assigned-to-the-authenticated-user">issues under one of your GitHub organizations</a>, call <code>GET /orgs/&lt;org&gt;/issues</code>:</p>
<pre><code>$ curl -i -H &quot;Authorization: token ghp_16C7e42F292c6912E7710c838347Ae178B4a&quot;\
    https://api.github.com/orgs/rails/issues</code></pre>
<p>We can also get <a href="https://docs.github.com/en/rest/reference/issues#list-repository-issues">all the issues under a single repository</a>:</p>
<pre><code>$ curl -i https://api.github.com/repos/rails/rails/issues</code></pre>
<h3 id="pagination"><a href="https://docs.github.com/en/rest/guides/getting-started-with-the-rest-api#pagination">Pagination</a></h3>
<p>A project the size of Rails has thousands of issues. We’ll need to <a href="https://docs.github.com/en/rest#pagination">paginate</a>, making multiple API calls to get the data. Let’s repeat that last call, this time taking note of the response headers:</p>
<pre><code>$ curl -i https://api.github.com/repos/rails/rails/issues

&gt; HTTP/2 200

&gt; ...
&gt; Link: &lt;https://api.github.com/repositories/8514/issues?page=2&gt;; rel=&quot;next&quot;, &lt;https://api.github.com/repositories/8514/issues?page=30&gt;; rel=&quot;last&quot;
&gt; ...</code></pre>
<p>The <a href="https://www.w3.org/wiki/LinkHeader"><code>Link</code> header</a> provides a way for a response to link to external resources, in this case additional pages of data. Since our call found more than thirty issues (the default page size), the API tells us where we can find the next page and the last page of results.</p>
<h3 id="creating-an-issue"><a href="https://docs.github.com/en/rest/guides/getting-started-with-the-rest-api#creating-an-issue">Creating an issue</a></h3>
<p>Now that we’ve seen how to paginate lists of issues, let’s <a href="https://docs.github.com/en/rest/reference/issues#create-an-issue">create an issue</a> from the API.</p>
<p>To create an issue, we need to be authenticated, so we’ll pass an OAuth token in the header. Also, we’ll pass the title, body, and labels in the JSON body to the <code>/issues</code> path underneath the repository in which we want to create the issue:</p>
<pre><code>$ curl -i -H &#39;Authorization: token ghp_16C7e42F292c6912E7710c838347Ae178B4a&#39;\
$    -d &#39;{\
$         &quot;title&quot;: &quot;New logo&quot;,\
$         &quot;body&quot;: &quot;We should have one&quot;,\
$         &quot;labels&quot;: [&quot;design&quot;]\
$       }&#39;\
$    https://api.github.com/repos/pengwynn/api-sandbox/issues

&gt; HTTP/2 201
&gt; Location: https://api.github.com/repos/pengwynn/api-sandbox/issues/17
&gt; X-RateLimit-Limit: 5000

&gt; {
&gt;   &quot;pull_request&quot;: {
&gt;     &quot;patch_url&quot;: null,
&gt;     &quot;html_url&quot;: null,
&gt;     &quot;diff_url&quot;: null
&gt;   },
&gt;   &quot;created_at&quot;: &quot;2012-11-14T15:25:33Z&quot;,
&gt;   &quot;comments&quot;: 0,
&gt;   &quot;milestone&quot;: null,
&gt;   &quot;title&quot;: &quot;New logo&quot;,
&gt;   &quot;body&quot;: &quot;We should have one&quot;,
&gt;   &quot;user&quot;: {
&gt;     &quot;login&quot;: &quot;pengwynn&quot;,
&gt;     &quot;gravatar_id&quot;: &quot;7e19cd5486b5d6dc1ef90e671ba52ae0&quot;,
&gt;     &quot;avatar_url&quot;: &quot;https://secure.gravatar.com/avatar/7e19cd5486b5d6dc1ef90e671ba52ae0?d=https://a248.e.akamai.net/assets.github.com%2Fimages%2Fgravatars%2Fgravatar-user-420.png&quot;,
&gt;     &quot;id&quot;: 865,
&gt;     &quot;url&quot;: &quot;https://api.github.com/users/pengwynn&quot;
&gt;   },
&gt;   &quot;closed_at&quot;: null,
&gt;   &quot;updated_at&quot;: &quot;2012-11-14T15:25:33Z&quot;,
&gt;   &quot;number&quot;: 17,
&gt;   &quot;closed_by&quot;: null,
&gt;   &quot;html_url&quot;: &quot;https://github.com/pengwynn/api-sandbox/issues/17&quot;,
&gt;   &quot;labels&quot;: [
&gt;     {
&gt;       &quot;color&quot;: &quot;ededed&quot;,
&gt;       &quot;name&quot;: &quot;design&quot;,
&gt;       &quot;url&quot;: &quot;https://api.github.com/repos/pengwynn/api-sandbox/labels/design&quot;
&gt;     }
&gt;   ],
&gt;   &quot;id&quot;: 8356941,
&gt;   &quot;assignee&quot;: null,
&gt;   &quot;state&quot;: &quot;open&quot;,
&gt;   &quot;url&quot;: &quot;https://api.github.com/repos/pengwynn/api-sandbox/issues/17&quot;
&gt; }</code></pre>
<p>The response gives us a couple of pointers to the newly created issue, both in the <code>Location</code> response header and the <code>url</code> field of the JSON response.</p>
<h2 id="conditional-requests"><a href="https://docs.github.com/en/rest/guides/getting-started-with-the-rest-api#conditional-requests">Conditional requests</a></h2>
<p>A big part of being a good API citizen is respecting rate limits by caching information that hasn’t changed. The API supports <a href="https://docs.github.com/en/rest#conditional-requests">conditional requests</a> and helps you do the right thing. Consider the first call we made to get defunkt’s profile:</p>
<pre><code>$ curl -i https://api.github.com/users/defunkt

&gt; HTTP/2 200
&gt; etag: W/&quot;61e964bf6efa3bc3f9e8549e56d4db6e0911d8fa20fcd8ab9d88f13d513f26f0&quot;</code></pre>
<p>In addition to the JSON body, take note of the HTTP status code of <code>200</code> and the <code>ETag</code> header. The <a href="http://en.wikipedia.org/wiki/HTTP_ETag">ETag</a> is a fingerprint of the response. If we pass that on subsequent calls, we can tell the API to give us the resource again, only if it has changed:</p>
<pre><code>$ curl -i -H &#39;If-None-Match: &quot;61e964bf6efa3bc3f9e8549e56d4db6e0911d8fa20fcd8ab9d88f13d513f26f0&quot;&#39;\
$    https://api.github.com/users/defunkt

&gt; HTTP/2 304</code></pre>
<p>The <code>304</code> status indicates that the resource hasn’t changed since the last time we asked for it and the response will contain no body. As a bonus, <code>304</code> responses don’t count against your <a href="https://docs.github.com/en/rest#rate-limiting">rate limit</a>.</p>
<p>Woot! Now you know the basics of the GitHub API!</p>
<ul>
<li>Basic &amp; OAuth authentication</li>
<li>Fetching and creating repositories and issues</li>
<li>Conditional requests</li>
</ul>
<p>Keep learning with the next API guide <a href="https://docs.github.com/en/guides/basics-of-authentication">Basics of Authentication</a>!</p>
</body>
</html>
